var status_cat = 0;
$(document).ready(function(){
	//修改商品
    //纪录最开始的商品购买赠送积分点数
    defaultScore=$('#txtScore').val();
    //设置商品的赠送积分比例
    InitCategoryRate(cid);
	if(pid != '0' && cid != '0'){
        //绑定属性和参数
        var props=propertes.props;
		var paras=propertes.paras;
		$.each(props,function(i,n){
			if(n!=undefined && n.value!=0){
				$("select[name=prop]").eq(n.id-1).val(n.value);
			};
		});
		if(paras!= undefined ){
		    $.each(paras,function(i,n){
			    $.each(n.options,function(j,m){
				    $("input[name=group]").eq(n.id-1).siblings("dl").find("input[name=paravalue]").eq(m.index-1).val(m.value);
			    });
		    });
        }
        //绑定相关商品删除事件
        BindDeleteEvent(1);
        //绑定附件商品删除事件
        BindDeleteEvent(2);
        //绑定赠送商品删除事件
        BindDeleteEvent(3);
        //绑定赠送礼品删除事件
        BindDeleteEvent(4);
    };
    setInterval(function(){
		if(getQueryStringRegExp('from') != 'list'){
			$('div.save').css('top',$(window).height()-$('div.save').height()); //设置底部分页区域的位置
			$('#container').css('height',$(window).height()-$('div.save').height()-$(".sub_container_title").height()-$(".tabmenu").height()-20); //设置内容区域的高度
		}else{//从列表页面链接过来修改
			var windowHeight = $('#frmHeight',window.parent.document).val();
			$('div.save').css('top',windowHeight-$('div.save').height()); //设置底部分页区域的位置
			$('#container').css('height',windowHeight-$('div.save').height()-$(".sub_container_title").height()-$(".tabmenu").height()-20); //设置内容区域的高度
		}
    },1000);
    //顶部Tab效果
    $('li.menuitem').each(function(index){
        $(this).click(function(){
            $(this).addClass('tabon').removeClass('tabout').siblings('.menuitem').removeClass('tabon').addClass('tabout');
            if(index != 0){
                $('div.tab').hide();
                $('div.tab').eq(index - 1).show();
            }else{
                $('div.tab').show();
            }
        });
    });
    if($.query.get('ProductID') == ''){$('#cbxAutoCreate').attr('checked','checked')};//添加商品默认将checkbox选中
    $('#cbxAutoCreate').attr('checked') ? $('#txtProductNo').hide() : $('#txtProductNo').show();
    $('#cbxAutoCreate').click(function(){
        if($(this).attr('checked')){
            $('#txtProductNo').hide();
        }else{
            $('#txtProductNo').show();
        }
    });
    //更改分类
    $("#btnChangeCat").click(function(){
		if(confirm("重新选择分类将重新关联品牌和扩展属性，确认吗？")){
            $('#ShowCategory').popup({width:'60%',height:'80%',popupHead:'SelectCategoryHead',btnClose:'popupClose'});
            if(status_cat == 0){GetCategorys(0,1,$('#catpath').val());status_cat=1;};
		};
    }); 
    //库存警告
    $("#cbxNeedAlert").click(function(){
        if($(this).attr("checked")){
            $("#mininum").show();
        }else{
            $("#mininum").hide();
        }
    });
    //设置商品赠送的默认积分.当商品已设有赠送积分时不要再设此值。
    $('#txtMemberPrice').keyup(function(){
        if(defaultScore==0){
            if(defaultScoreRate!=0)
            $('#txtScore').val(Math.floor($('#txtMemberPrice').val()*defaultScoreRate));
        }
    });
    
    //更改品牌,重新获取售后服务
    $("#ddlBrand").change(function(){
		if($(this).val() != "0"){		
			$.ajax({
				url:'ProductAdd_Step2.aspx?type=ajax&Action=GetAfterService&bid='+ $(this).val() + '&NoCopyRight=1',
				cache:false,
				success:function(data){
					if(!checkLoginStatus(data)){return false;}//是否要重新登陆
						$("#ftbAfterService").val(data);
						ftbAfterService_editor.focus();
						ftbAfterService_editor.document.open();
						ftbAfterService_editor.document.write("");
						ftbAfterService_editor.document.close();
						var sel = ftbAfterService_editor.document.selection.createRange();
						sel.pasteHTML(data);
				},//end seccess
				error:function(){alert('error 2');}
			});//end ajax
        };
    });
    //$(".upic").uploadPreview({ width: 0, height: 0, imgDiv: ".preview", imgType: ["gif","jpg","jpeg"], maxwidth: 3000, maxheight: 3000 });
    $('.upic').change(function(){
        var filename=$(this).val().replace(/.*(\/|\\)/, "");//文件名
        var fileExt=(/[.]/.exec(filename)) ? /[^.]+$/.exec(filename.toLowerCase()) : '';//后缀名
        if(fileExt != "jpeg" && fileExt != "jpg" && fileExt != "gif" && fileExt != "png"){
            alert('请选择一个jpg或gif的图片文件');
            return;
        };
		$(this).parent().parent().parent().addClass('support');
		$(this).parent().parent().siblings("[name='isDel']").val("1");
		if($.browser.msie)
		{
		    if($.browser.version == "6.0")
		    {
		        $(this).parent().parent().siblings(".preview").html('<img src="'+$(this).val()+'"/>');
		    }else{
		        var previewDiv =  $(this).parent().parent().siblings(".preview");
		        previewDiv.css({ filter: "progid:DXImageTransform.Microsoft.AlphaImageLoader(sizingMethod=image)" });
                previewDiv[0].filters.item("DXImageTransform.Microsoft.AlphaImageLoader").sizingMethod = "scale";
                try 
                {
                    previewDiv[0].filters.item('DXImageTransform.Microsoft.AlphaImageLoader').src = getPath($(this)[0]);
                }
                catch (e) 
                {
                    alert("无效的图片文件！");
                    return;
                }
		    }
		}
		else
		{
			var data=$(this)[0].files.item(0).getAsDataURL();			
			$(this).parent().parent().siblings(".preview").html('<img src="'+data+'"/>');
			return;
		}
		$(this).parent().parent().parent().mouseover(function(){$(this).addClass('hover');}).mouseout(function(){$(this).removeClass('hover');});		
    });
    
    $('.moveleft').click(function(){
        var currObj = $(this).parent().parent();
        var addObj = currObj.prev().clone(true);
        if(addObj.hasClass("first")){
            currObj.addClass("first");
            addObj.removeClass("first");
        };
        if(currObj.hasClass("last")){
            currObj.removeClass("last");
            addObj.addClass("last");
        };
        currObj.after(addObj);
        currObj.prev().remove();       
    });
    
    $('.moveright').click(function(){
        var currObj = $(this).parent().parent();
        var addObj = currObj.next().clone(true);
        if(addObj.hasClass("last")){
            currObj.addClass("last");
            addObj.removeClass("last");
        };
        if(currObj.hasClass("first")){
            currObj.removeClass("first");
            addObj.addClass("first");
        };
        currObj.before(addObj);
        currObj.next().remove();
    });
    
    $('.del').click(function(){
        $(this).parent().siblings("[name='isDel']").val("1");
		var file = $(this).parent().siblings(".upload").children().children(".upic");
		file.after(file.clone(true).val("")).remove();
		$(this).parent().siblings(".preview").after('<div class="preview"></div>').remove();
		//$(this).parent().siblings(".preview").empty();
		$(this).parent().parent().removeClass('support').mouseout().unbind('mouseover');
    });
    
    if($.browser.msie){
		$('li').filter('.support').mouseover(function(){$(this).addClass('hover');}).mouseout(function(){$(this).removeClass('hover');});
	};
	$.validator.methods.strlen= function(value,element,param){
       var  str =$(element).val();
       var  len =0;
       for(var i=0;i<str.length;i++){
          if(str.charCodeAt(i)>255){
             len +=2;
          }
          else{
             len +=1;
          }
       }
       return (len -param)<=0;
	}
	//$("#form1").validate({meta: "validate",debug:"ture"});
	$("#form1").validate({
		event: "keyup",
		rules: {
			txtName: {
				required: true,
				strlen:60
			},
			txtSubName: {
				strlen:50
			},
			txtWeight: {
				required: true,
				number:true,
				range: [0.001,100]
			},
			txtMarketPrice: {
				required: true,
				number:true,
				range: [0,999999]
			},
			txtMemberPrice: {
				required: true,
				number:true,
				range: [0,999999]
			},
			txtStorage: {
				required: true,
				number:true,
				range: [1,999999]
			},			
			ftbContent:{
				required: true
			},			
			
            ftbPackingList: {
				strlen:250
			},
			
            ftbAfterService: {
				strlen:500
			},
			
			txtScore:{
			    number:true,
				range: [0,999999]
			},
			
		    txtUseScore:{
			    number:true,
				range: [0,999999]
			}
		},
		
		messages: {
			txtName: {
				required: "请输入商品名称",
				strlen: "最大长度只能在30个汉字(60个字符)以内"
			},
			txtSubName: {
				strlen: "最多允许输入25个汉字50个字符)"
			},
			txtWeight: {
				required: "请输入商品重量",
				range: "请输入合法的商品重量"
			},
			txtMarketPrice: {
				required: "请输入市场价",
				range: "请输入合法的市场价(0-999999)"
			},
			txtMemberPrice: {
				required: "请输入会员价",
				range: "请输入合法的会员价(0-999999)"
			},
			txtStorage: {
				required: "请输入库存",
				range: "请输入合法的库存(1-999999)"
			},
            ftbContent: {
				required: "请输入商品详细描述"
			},
            ftbPackingList: {
				strlen: "最多允许输入250个汉字500个字符"
			},
            ftbAfterService: {
				strlen: "最多允许输入500个汉字1000个字符"
			},
			txtScore: {
				range: "请输入合法的积分点数(1-999999)"
			},
			txtUseScore: {
				range: "请输入合法的使用积分(1-999999)"
			}
		},
		debug:"false",
		submitHandler:function(form){
			GetPropPara();
			if(!CheckPrice())return false;
			CountPIDs();//获取要添加或要删除的相关商品的ID,配件ID
			//$(form).ajaxSubmit();
			form.submit();
		}
	});
});//end document.ready
function CheckPrice()
{
     var flag = true;
     $('input[name=price]').each(function(){
        if($(this).val()=='')
        {
            alert("请输入价格");
            flag = false;
            $(this).focus();
            return false;
        }
        if(isNaN(Number($(this).val())))
        {
            alert("请输入有效的价格");
            flag = false;
            $(this).focus();
            return false;
        }
//        if($(this).val()!=$(this).val().replace(/\D/g,""))
//        {
//            alert("请输入有效的价格");
//            $(this).focus();
//            return false;
//        }
    });
     return flag;
}
function GetPropPara()
{
	//参数
	var gcount=$("input[name=group]").length;
	var paras='"paras":[';
	if(gcount!=0){
		var flag=false;
		$("input[name=group]").each(function(i){
			var tempGroup='{"id":"'+(i+1)+'","group":"'+$(this).val()+'","options":[';
			var paraname=$(this).siblings("dl").find("input[name=paraname]");
			var tempGroupValue="";
			paraname.each(function(j){
				var tempValue=$(this).next().val().Trim().replace(/\"/g,"“");
				if(tempValue!=""){
					tempGroupValue+='{"index":"'+(j+1)+'","name":"'+$(this).val()+'","value":"'+tempValue+'"}';
					tempGroupValue+=',';
				};
			});
			if(tempGroupValue!=""){
				tempGroupValue=tempGroupValue.substring(0,tempGroupValue.length-1);
				paras+=tempGroup;
				paras+=tempGroupValue;
				paras+=']}'
				paras+=',';
				flag=true;
			};			
		});
		if(flag){
			paras=paras.substring(0,paras.length-1);
		};		
	};
	paras+=']';
	$('input:hidden[name="paras"]').val(paras);
}

//获得上传控件的值，obj为上传控件对象
function getPath(obj) {
    if (obj) {
        if (window.navigator.userAgent.indexOf("MSIE") >= 1) {
            obj.select();
            return document.selection.createRange().text;
        }
        else if (window.navigator.userAgent.indexOf("Firefox") >= 1) {
            if (obj.files) {
                return obj.files.item(0).getAsDataURL();
            }
            return obj.value;
        }
        return obj.value;
    }
}
//清空上传控件的值，obj为上传控件对象
function clearvalue(obj) {
    obj.select();
    document.execCommand("delete");
}  
//获取分类
function GetCategorys(cid,depth,path){
	 $.ajax({
		type:"get",
        dataType:"json",
        url:"ProductAdd_Step1.aspx?NoCopyRight=1&action=GetCategorys&cid="+cid,
        cache:false,
        success:function(msg){
			var parentObj = $("<li><ul><ul></li>").appendTo($("#cul"));
            var data = msg.Categorys;
			$.each(data,function(i,n){
				var item=$("<li>"+n.Name+"</li>").addClass("citem").appendTo(parentObj).click(function(){
					temp_cid=n.CategoryID;
					temp_cno=n.CategoryNo;
					if(depth==1){
						temp_catname=n.Name;
						temp_catpath=n.CategoryID;
					}else{
						var arr_catname = temp_catname.split('>>');
						var arr_catpath = temp_catpath.split(',');
						temp_catname="";
						temp_catpath="";
						$.each(arr_catpath,function(p,q){
							if(p<(depth-1)){
								if(p!=0){
									temp_catname += ">>";
									temp_catpath += ",";
								};
								temp_catname += arr_catname[p];
								temp_catpath += arr_catpath[p];
							};						
						});	
						temp_catname += ">>"+n.Name;
						temp_catpath += ","+n.CategoryID;
					};
					parentObj.nextAll().remove();//绑定下级分类前清空之前的数据
					$("#next").unbind("click");//取消下一步按钮的click事件
					if(n.Child=="0"){						
						//最底层分类的时候激活下一步按钮并绑定事件			
						$("#next").removeClass("disable");
						$("#next").addClass("enable");
						$("#next").click(function(){
							if($("#catid").val() != temp_cno){
								InitFB(temp_cid);
								InitCategoryRate(temp_cno);
								$("#catid").attr("value",temp_cno);
							};
							$("#catname").text(temp_catname);
							$("#catpath").attr("value",temp_catpath);
							disablePopup($("#ShowCategory"),$("#backgroundPopup"));
						});
					}else{						
						$("#next").removeClass("enable");
						$("#next").addClass("disable");
						GetCategorys(n.CategoryID,depth+1,path);
					};
					$(this).siblings().removeClass("selected");
					$(this).addClass("selected");
				});//end click
				if(n.Child!="0"){
					item.addClass("more");
				};
				if(n.CategoryID==path.split(',')[depth-1]){
					item.siblings().removeClass("selected");
					item.addClass("selected");
					if(depth!=1){
						temp_catname += ">>";
						temp_catpath +=",";
					};
					temp_catname += n.Name;
					temp_catpath += n.CategoryID;
					if(depth==(path.split(',').length)){
						//最底层分类的时候激活下一步按钮并绑定事件
						$("#next").removeClass("disable");
						$("#next").addClass("enable");
						$("#next").click(function(){
							if($("#catid").val() != temp_cno){
								InitFB(temp_cid);
								InitCategoryRate(temp_cno);
								$("#catid").attr("value",temp_cno);
							};
							$("#catname").text(temp_catname);
							$("#catpath").attr("value",temp_catpath);
							disablePopup($("#ShowCategory"),$("#backgroundPopup"));
						});
					}else{					
						GetCategorys(n.CategoryID,depth+1,path);
					};
				};
            });//end each
        },//end success
        error:function(XMLHttpRequest,textStatus){if(textStatus=='parsererror'){alert('身份已过期,请重新登陆!');parent.window.location="../../adminlogin.aspx";}}
    });//end ajax
};
//修改分类后重新绑定扩展属性和品牌
function InitFB(arg){
    //获取扩展属性
    if(arg==0){return false;};
    $("#prop tr").remove();
    $("#para").html("");
    $.ajax({
        url:'ProductAdd_Step2.aspx?type=ajax&Action=GetFieldValues&cid='+arg + '&NoCopyRight=1',
        cache:false,
        success:function(data){
            if(!checkLoginStatus(data)){return false;}//是否要重新登陆
            if(data != ''){
				if(data.split('^@^')[0] != ''){
				    var prop=eval('('+data.split('^@^')[0]+')');
				    $.each(prop.props,function(i,n){
					    var tempRow=$("<tr></tr>").appendTo($("#prop"));
					    var tempCell1=$("<th class='tl'>"+n.name+"：</td>").appendTo(tempRow);
					    var tempCell2=$("<td class='tr'></td>").appendTo(tempRow);
					    var tempSelect=$("<select name='prop'><option value='0'>请选择"+n.name+"</option></select>").appendTo(tempCell2);
					    $.each(n.options,function(j,m){
						    var tempOption=$("<option value='"+(j+1)+"'>"+m.value+"</option>").appendTo(tempSelect);
					    });
				    });
				}
				
				if(data.split('^@^')[1] != ''){
				    var para=eval('('+data.split('^@^')[1]+')');
				        $.each(para.paras,function(i,n){
					    var tempItem=$("<div class='para_group'><input type='hidden' name='group' value='"+n.group+"'/><label>"+n.group+"</label></div>").appendTo($("#para"));					
					    $.each(n.options,function(j,m){
						    var tempRow=$("<dl></dl>").appendTo(tempItem);
						    var tempCell1=$("<dt>"+m.name+"：</dt>").appendTo(tempRow);
						    var tempCell2=$("<dd><input type='hidden' name='paraname' value='"+m.name+"'/><input type='text' name='paravalue' /></dd>").appendTo(tempRow);
					    });
					    var tempRow=$("<dl class='clear'></dl>").appendTo(tempItem);	
				    });
				}
				
			};
        },//end seccess
        error:function(){alert('error:GetFieldValues');}
    });//end ajax
    
    //获取品牌
    $.ajax({
        url:'ProductAdd_Step2.aspx?type=ajax&Action=GetBrandByCatID&cid='+arg +(pid==0 ? "" : "&ProductID="+pid)+'&NoCopyRight=1',
        cache:false,
        success:function(data){
            $('#ddlBrand').html(data);
        },
        error:function(){alert('error:GetBrandByCatID');}
    });   
    return false;
};
function InitCategoryRate(arg){
    //设置商品的赠送积分比例
    $.ajax({
        url:'ProductAdd_Step2.aspx?type=ajax&Action=GetScoreRateByCatID&cid='+arg+'&NoCopyRight=1',
        cache:false,
        success:function(data){
            $('#txtScoreRate').val(data);
            $('#txtScoreRate').attr("disabled","true");
            defaultScoreRate=data;
        },
        error:function(){alert('error:GetScoreRateByCatID');}
    });
}